<template>
    <client-only placeholder="Loading...">
        <div class="section">
            <div class="container is-fullwidth">
                <div class="columns">
                    <div class="column is-two-thirds">
                        <ShippingAddress
                            :addresses="addresses"
                            v-model="form.address_id"
                            @toggleShipping="toggleShipping"
                        />


                        <ShippingOptions
                            v-if="shippingMethods && isVisibleShipping"
                            v-model="form.shipping_method_id"
                            :shippingMethods="shippingMethods"
                        />



                    <PaymentMethods
                        :paymentMethods="paymentMethods"
                        v-model="form.payment_method_id"
                        @created="refreshInstallments"
                    >

                        <template slot="cvv" v-if="paymentMethod">
                            <div v-if="paymentMethod.isType === 'credit_card'">
                                <b-field label="CVV">
                                    <b-input class="cvv" ref="cvv" type="text" v-model="cvv" data-checkout="securityCode" />
                                </b-field>
                            </div>
                        </template>
                        <template slot="installments" v-if="paymentMethod">
                            <div v-if="paymentMethod.isType === 'credit_card'">
                                <Installments
                                    :installments="installments"
                                    v-model="form.installments"
                                />
                            </div>
                        </template>

                    </PaymentMethods>
                    </div>
                    <div class="column summary">
                        <article class="box" v-if="products.length">
                                <Summary
                                :cart="{
                                    totalQtd: totalItem,
                                    subtotal: subtotal,
                                    freteValorC: shippingPrice,
                                    totalCart: total
                                }">
                                <template slot="submit">
                                    <Submit
                                        :empty="empty"
                                        :submitting="submitting"
                                        @submit="order"
                                    />
                                </template>
                                </Summary>
                        </article>
                    </div>
                </div>
            </div>
        </div>
    </client-only>
</template>

<script>
import CartOverview from '@/components/cart/CartOverview'
import ShippingAddress from '@/components/checkout/addresses/ShippingAddress'
import PaymentMethods from '@/components/checkout/paymentMethods/PaymentMethods'
import ShippingOptions from '@/components/checkout/shippings/ShippingOptions'
import Installments from '@/components/checkout/paymentMethods/Installments'
import Submit from '@/components/orders/Submit'
import Summary from '@/components/cart/Summary'

import { mapGetters, mapActions } from 'vuex'

export default {
    transition: 'page',
    layout: 'checkout',

    middleware: 'auth-user',

    data(){

        return {
            submitting: false,
            installments: [],
            addresses: [],
            isVisibleShipping: true,
            credentials: [],
            mpCredentials: [],
            paymentMethods: [],
            shippingMethods: [],
            paymentMethodsAvaliables: [],
            cvv: null,
            form: {
                address_id: null,
                shipping_method_id: null,
                payment_method_id: null,
                installments: 1
            },
        }
    },

    watch: {
      total(value) {
        if (this.paymentMethod.isType === 'credit_card') {
          this.getInstallments(this.card_type, this.$getAmountValue(value))
        }
      },

        'form.address_id' (addressId) {
            this.getShippingMethodsForAddress(addressId)
            .then(() => {
                // console.log(this.shippingMethods)
                this.shipping = this.shippingMethods.find(s => s.default == true)
            })
        },

        'form.shipping_method_id'(shippingMethodId){
            this.shipping = this.shippingMethods.find(s => s.id == shippingMethodId)
        },
        'form.payment_method_id'(paymentMethodId) {
            if (typeof this.paymentMethod !== 'undefined' && this.paymentMethod !== null && this.paymentMethod !== '') {
                if (this.paymentMethod.isType === 'credit_card'){
                    this.refreshInstallments()
                }
            }
        },
        cvv(value) {
            if (value.length === 3) {
                this.submitting = false
            }
        }
    },

    components: {
        CartOverview,
        ShippingAddress,
        PaymentMethods,
        Installments,
        Submit,
        Summary,
        ShippingOptions
    },

    methods: {
        ...mapActions({
            setShipping: 'cart/setShipping',
            getCart: 'cart/getCart',
            flash: 'alert/flash',
            setTotalItem: 'cart/setTotalItem',
            setPaymentMethod: 'cart/setPaymentMethod'
        }),

        toggleShipping(value) {
            this.isVisibleShipping = value
        },

        refreshInstallments(paymentMethod) {
            if (paymentMethod) {
                this.paymentMethod = paymentMethod
            }
            if (this.paymentMethod.isType === 'credit_card') {
                this.getInstallments(this.card_type, this.$getAmountValue(this.total))
            }
        },

        getInstallments(paymentMethodId, amount, issuerId){
            if (window.Mercadopago) {
                window.Mercadopago.getInstallments({
                    "payment_method_id": paymentMethodId,
                    "amount": parseFloat(amount),
                    "issuer_id": issuerId ? parseInt(issuerId) : undefined
                }, this.setInstallments);
            }
        },

        setInstallments(status, response){
            this.installments = []
            if (status == 200) {
                response[0].payer_costs.forEach( payerCost => {
                    this.installments.push(payerCost)
                });
            } else {
                alert(`installments method info error: ${ JSON.stringify(response) }`);
            }
        },

        async order(){
            this.submitting = true
            const fieldCvv = this.$refs.cvv
            let token = null

            try {
                if (this.paymentMethod.isType === 'credit_card') {

                    if (this.cvv === null || this.cvv === '') {
                        fieldCvv.focus()
                        return
                    }

                    const cardToken = new Promise((resolve, reject) => {
                        window.Mercadopago.clearSession()
                        window.Mercadopago.createToken({ cardId: this.paymentMethod.card.id, securityCode: this.cvv }, function(status, response) {
                            if (status == 200 || status == 201) {
                                resolve(response.id)
                            } else {
                                reject(response)
                            }
                        })
                    })

                    cardToken.then(async response => {
                        await this.$axios.$post('/api/orders', {
                            ...this.form, token: response
                        }).then(async (response) => {

                            await this.getCart()
                            this.$router.push(this.localePath({ name: 'orders'}))
                        })
                    })
                } else {
                    await this.$axios.$post('/api/orders', {
                            ...this.form
                        }).then(async (response) => {

                            await this.getCart()
                            this.$router.push(this.localePath({ name: 'orders'}))
                        })
                }

            }catch (e){
                console.log(e.message)

                this.getCart()
            }

            this.submitting = false
        },

        async getShippingMethodsForAddress(addressId) {
            let response = await this.$axios.$get(`/api/addresses/${addressId}/shipping`)

            this.shippingMethods = response.data

            // return response
        },

        onScriptLoaded(event = null) {
            window.Mercadopago.setPublishableKey(this.credentials.key)
            if (event) {
                if (this.paymentMethod) {
                    if (this.paymentMethod.isType === 'credit_card') {
                        this.refreshInstallments()
                    }
                }

            } else {
                // console.log("Already existed");
            }

        }
    },

    mounted(){
        this.$nextTick(() => {
            if (!process.server && !window.Mercadopago) {
                const script = document.createElement('script')
                script.onload = this.onScriptLoaded
                script.type = 'text/javascript'
                script.src = "https://secure.mlstatic.com/sdk/javascript/v1/mercadopago.js"
                document.head.appendChild(script)
            } else {
                this.onScriptLoaded()
            }

            if (this.paymentMethods) {
                this.paymentMethod = this.paymentMethods.find(s => s.default === true)
            }

            if (this.shippingMethods){
                this.shipping = this.shippingMethods.find(s => s.default === true)
            }
        })
    },

    computed: {
        ...mapGetters({
            subtotal: 'cart/subtotal',
            total: 'cart/total',
            empty: 'cart/empty',
            products: 'cart/products',
            // shipping: 'cart/shipping',
            totalItem: 'cart/totalItemCart',
            // paymentMethod: 'cart/paymentMethod',
            // addresses: 'address/addresses'
        }),

        card_type() {
            return this.paymentMethod && this.paymentMethod.card_type.substring(0, 6).toLowerCase()
        },

        paymentMethod: {
            get() {
                return this.$store.state.cart.paymentMethod
            },
            set(value) {
                this.$store.commit('cart/SET_PAYMENT_METHOD', value)
            }
        },

        shipping: {
            get() {
                return this.$store.state.cart.shipping
            },
            set(value) {
                this.$store.commit('cart/SET_SHIPPING', value)
            }
        },

        shippingPrice() {
            return this.shipping ? this.shipping.price : ''
        }
    },

    async asyncData({ context, app, store, route }) {

        let addresses = await store.dispatch('address/getAddresses')
        let paymentMethods = await app.$axios.$get('/api/payment-methods')
        let credentials = await app.$axios.$get('/api/mp-credentials')
        let shippingMethods = null

        if (addresses.data.length){
            let addressId = addresses.data.find(a => a.default == true).id
            shippingMethods = await app.$axios.$get(`/api/addresses/${addressId}/shipping`)
        }

        return {
            addresses: addresses.data,
            credentials: credentials.data,
            paymentMethods: paymentMethods.data,
            shippingMethods: shippingMethods && shippingMethods.data
        }

    },
}
</script>

<style scoped>

    Summary {
        font-size: .85em;
    }

    .cvv {
        width: 6rem;
    }

    .section {
        padding-top: 0;
    }

    .summary > .message > .message-body {
        font-size: .85em
    }

    .block {
        border: 1.5px solid #CCC;
        padding: 10px;
        font-size: .8em;
        /* background-color: rgb(240, 240, 240); */
    }

    .block:hover {
        border: 2px solid #8c67ef;
        /* background-image: linear-gradient(180deg, rgb(240, 240, 240), rgb(255, 255, 255)); */
    }


</style>
